#include <itpp/itbase.h>
#include "../bdm/stat/libBM.h"
#include "../bdm/math/libDC.h"
#include "../bdm/math/chmat.h"

using namespace itpp;

//These lines are needed for use of cout and endl
using std::cout;
using std::endl;

int main()
{
	RV th = RV ( "1 2","{a b }","1 1","0 0");
	RV r = RV ( "3 4" );

	cout << th << r << endl;

	ldmat ld = ldmat("1 0;0.5 1","1.1 1.3");
	vec v = "1 -0.1";
	
	cout << "Test to_mat"<<endl;
//	cout << ld << endl;
	cout << ld.to_mat()<<endl;

	cout << "Test opupdt" <<endl;
	ldmat ldup = ld;
	ldup.opupdt(v,1);
	cout << ldup.to_mat()<<endl;

	cout << "Test +="<<endl;
	ldmat ld2x = ld;
	ld2x+=ld;
	cout << ld.to_mat() << ld2x.to_mat() <<endl;

	cout << "Test ldinv()"<<endl;
	ldmat Il = ld; 
	ld.inv(Il); // 
	mat I = Il.to_mat()*ld.to_mat();
	cout << "ld:"<<Il.to_mat() << "eye:"<< I <<endl;

	cout << "Test ldform()"<<endl;
	mat V = "1 2; 2 13"; 
	ldmat lV(V);
	ldmat ilV(V);  
	lV.inv(ilV);
	cout << "ld:" << lV << "eye:"<< V*(ilV.to_mat()) <<endl;

	cout << "Test logdet()"<<endl;
	chmat chV(V);
	cout << "ch:" << chV.to_mat() <<endl;
	cout << "log(det(V)):"<< chV.logdet() <<endl;
	cout << "qform : " << chV.qform(ones(2)) <<endl;
	

	//Exit program:
	getchar();
	return 0;

}
